#set UnusedPin
set_property BITSTREAM.CONFIG.UNUSEDPIN Pullnone [current_design]

#system slock
set_property PACKAGE_PIN Y18 [get_ports clk50m]
set_property IOSTANDARD LVCMOS33 [get_ports clk50m]

#reset active low,S4
set_property PACKAGE_PIN B21 [get_ports reset_n]
set_property IOSTANDARD LVCMOS33 [get_ports reset_n]

#led
set_property PACKAGE_PIN M22 [get_ports {led[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {led[0]}]
set_property PACKAGE_PIN N22 [get_ports {led[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {led[1]}]
set_property PACKAGE_PIN L21 [get_ports {led[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {led[2]}]
set_property PACKAGE_PIN K21 [get_ports {led[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {led[3]}]

#ͷؽӿ)
set_property PACKAGE_PIN N20 [get_ports camera_rst_n]
set_property IOSTANDARD LVCMOS33 [get_ports camera_rst_n]
set_property PACKAGE_PIN J2 [get_ports {camera_data[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera_data[0]}]
set_property PACKAGE_PIN J1 [get_ports {camera_data[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera_data[1]}]
set_property PACKAGE_PIN G1 [get_ports {camera_data[2]}]  
set_property IOSTANDARD LVCMOS33 [get_ports {camera_data[2]}]
set_property PACKAGE_PIN H2 [get_ports {camera_data[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera_data[3]}]
set_property PACKAGE_PIN F1 [get_ports {camera_data[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera_data[4]}]
set_property PACKAGE_PIN G2 [get_ports {camera_data[5]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera_data[5]}]
set_property PACKAGE_PIN D1 [get_ports {camera_data[6]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera_data[6]}]
set_property PACKAGE_PIN E1 [get_ports {camera_data[7]}]
set_property IOSTANDARD LVCMOS33 [get_ports {camera_data[7]}]
set_property PACKAGE_PIN M17 [get_ports camera_xclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera_xclk]
set_property PACKAGE_PIN B1 [get_ports camera_pclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera_pclk]
set_property PACKAGE_PIN A1 [get_ports camera_href]
set_property IOSTANDARD LVCMOS33 [get_ports camera_href]
set_property PACKAGE_PIN B2 [get_ports camera_vsync]
set_property IOSTANDARD LVCMOS33 [get_ports camera_vsync]
set_property PACKAGE_PIN L18 [get_ports camera_sdat]
set_property IOSTANDARD LVCMOS33 [get_ports camera_sdat]
set_property PULLUP true [get_ports camera_sdat]
set_property PACKAGE_PIN M20 [get_ports camera_sclk]
set_property IOSTANDARD LVCMOS33 [get_ports camera_sclk]
set_property PULLUP true [get_ports camera_sclk]

set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets camera_pclk_IBUF]

#HDMI1 HDMIӿ1
set_property PACKAGE_PIN K4 [get_ports hdmi1_clk_p]
set_property IOSTANDARD TMDS_33 [get_ports hdmi1_clk_p]
#set_property PACKAGE_PIN J4 [get_ports hdmi1_clk_n]
#set_property IOSTANDARD TMDS_33 [get_ports hdmi1_clk_n]
set_property PACKAGE_PIN L3 [get_ports {hdmi1_dat_p[0]}]
set_property IOSTANDARD TMDS_33 [get_ports {hdmi1_dat_p[0]}]
#set_property PACKAGE_PIN K3 [get_ports {hdmi1_dat_n[0]}]
#set_property IOSTANDARD TMDS_33 [get_ports {hdmi1_dat_n[0]}]
set_property PACKAGE_PIN L5 [get_ports {hdmi1_dat_p[1]}]
set_property IOSTANDARD TMDS_33 [get_ports {hdmi1_dat_p[1]}]
#set_property PACKAGE_PIN L4 [get_ports {hdmi1_dat_n[1]}]
#set_property IOSTANDARD TMDS_33 [get_ports {hdmi1_dat_n[1]}]
set_property PACKAGE_PIN M3 [get_ports {hdmi1_dat_p[2]}]
set_property IOSTANDARD TMDS_33 [get_ports {hdmi1_dat_p[2]}]
#set_property PACKAGE_PIN M2 [get_ports {hdmi1_dat_n[2]}]
#set_property IOSTANDARD TMDS_33 [get_ports {hdmi1_dat_n[2]}]
set_property PACKAGE_PIN H5 [get_ports hdmi1_oe]
set_property IOSTANDARD LVCMOS33 [get_ports hdmi1_oe]

#HDMI2 HDMIӿ2
set_property PACKAGE_PIN H4 [get_ports hdmi2_clk_p]
set_property IOSTANDARD TMDS_33 [get_ports hdmi2_clk_p]
#set_property PACKAGE_PIN G4 [get_ports hdmi2_clk_n]
#set_property IOSTANDARD TMDS_33 [get_ports hdmi2_clk_n]
set_property PACKAGE_PIN E2 [get_ports hdmi2_dat_p[0]]
set_property IOSTANDARD TMDS_33 [get_ports hdmi2_dat_p[0]]
#set_property PACKAGE_PIN D2 [get_ports hdmi2_dat_n[0]]
#set_property IOSTANDARD TMDS_33 [get_ports hdmi2_dat_n[0]]
set_property PACKAGE_PIN F3 [get_ports hdmi2_dat_p[1]]
set_property IOSTANDARD TMDS_33 [get_ports hdmi2_dat_p[1]]
#set_property PACKAGE_PIN E3 [get_ports hdmi2_dat_n[1]]
#set_property IOSTANDARD TMDS_33 [get_ports hdmi2_dat_n[1]]
set_property PACKAGE_PIN H3 [get_ports hdmi2_dat_p[2]]
set_property IOSTANDARD TMDS_33 [get_ports hdmi2_dat_p[2]]
#set_property PACKAGE_PIN G3 [get_ports hdmi2_dat_n[2]]
#set_property IOSTANDARD TMDS_33 [get_ports hdmi2_dat_n[2]]
set_property PACKAGE_PIN K2 [get_ports hdmi2_oe]
set_property IOSTANDARD LVCMOS33 [get_ports hdmi2_oe]

#5/4.3TFTģ飨ʹչGPIO2
set_property PACKAGE_PIN R17 [get_ports TFT_clk]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_clk]
set_property PACKAGE_PIN N17 [get_ports TFT_de]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_de]
set_property PACKAGE_PIN R18 [get_ports TFT_pwm]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_pwm]
set_property PACKAGE_PIN T18 [get_ports TFT_hs]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_hs]
set_property PACKAGE_PIN U18 [get_ports TFT_vs]
set_property IOSTANDARD LVCMOS33 [get_ports TFT_vs]
set_property PACKAGE_PIN J5 [get_ports {TFT_rgb[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[0]}]
set_property PACKAGE_PIN K6 [get_ports {TFT_rgb[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[1]}]
set_property PACKAGE_PIN R16 [get_ports {TFT_rgb[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[2]}]
set_property PACKAGE_PIN R14 [get_ports {TFT_rgb[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[3]}]
set_property PACKAGE_PIN P17 [get_ports {TFT_rgb[4]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[4]}]
set_property PACKAGE_PIN P6 [get_ports {TFT_rgb[5]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[5]}]
set_property PACKAGE_PIN N4 [get_ports {TFT_rgb[6]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[6]}]
set_property PACKAGE_PIN M6 [get_ports {TFT_rgb[7]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[7]}]
set_property PACKAGE_PIN N5 [get_ports {TFT_rgb[8]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[8]}]
set_property PACKAGE_PIN L6 [get_ports {TFT_rgb[9]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[9]}]
set_property PACKAGE_PIN M5 [get_ports {TFT_rgb[10]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[10]}]
set_property PACKAGE_PIN R1 [get_ports {TFT_rgb[11]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[11]}]
set_property PACKAGE_PIN P2 [get_ports {TFT_rgb[12]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[12]}]
set_property PACKAGE_PIN N3 [get_ports {TFT_rgb[13]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[13]}]
set_property PACKAGE_PIN P4 [get_ports {TFT_rgb[14]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[14]}]
set_property PACKAGE_PIN P5 [get_ports {TFT_rgb[15]}]
set_property IOSTANDARD LVCMOS33 [get_ports {TFT_rgb[15]}]
#TFTܽԼIOB
set_property  IOB true [get_ports {TFT_de}]
set_property  IOB true [get_ports {TFT_hs}]
set_property  IOB true [get_ports {TFT_vs}]
set_property  IOB true [get_ports {TFT_rgb[*]}]