/////////////////////////////////////////////////////////////////////////////////
// Company       : 人о·Ƽ޹˾
//                 http://xiaomeige.taobao.com
// Web           : http://www.corecourse.cn
// 
// Create Date   : 2019/05/01 00:00:00
// Module Name   : ov5640_ddr3_hdmi_1080p
// Description   : ͷɼݣDDR3棬HDMIӿ,1080p
// 
// Dependencies  : 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
/////////////////////////////////////////////////////////////////////////////////

module ov5640_ddr3_hdmi_1080p(
  //System clock reset
  input           clk50m        , //ϵͳʱ룬50MHz
  input           reset_n       , //λź
  //LED
  output [3:0]    led           ,
  //TFT Interface               
  output [15:0]   TFT_rgb       , //TFT
  output          TFT_hs        , //TFTͬź
  output          TFT_vs        , //TFTͬź
  output          TFT_clk       , //TFTʱ
  output          TFT_de        , //TFTʹ
  output          TFT_pwm       , //TFT
  //camera interface
  output          camera_sclk   ,
  inout           camera_sdat   ,
  input           camera_vsync  ,
  input           camera_href   ,
  input           camera_pclk   ,
  output          camera_xclk   ,
  input  [7:0]    camera_data   ,
  output          camera_rst_n  ,
  //hdmi1 interface
  output          hdmi1_clk_p   ,
  output          hdmi1_clk_n   ,
  output [2:0]    hdmi1_dat_p   ,
  output [2:0]    hdmi1_dat_n   ,
  output          hdmi1_oe      ,
  //hdmi1 interface
  output          hdmi2_clk_p   ,
  output          hdmi2_clk_n   ,
  output [2:0]    hdmi2_dat_p   ,
  output [2:0]    hdmi2_dat_n   ,
  output          hdmi2_oe      ,
  //DDR3 Interface
  // Inouts
  inout  [15:0]   ddr3_dq       ,
  inout  [1:0]    ddr3_dqs_n    ,
  inout  [1:0]    ddr3_dqs_p    ,
  // Outputs      
  output [13:0]   ddr3_addr     ,
  output [2:0]    ddr3_ba       ,
  output          ddr3_ras_n    ,
  output          ddr3_cas_n    ,
  output          ddr3_we_n     ,
  output          ddr3_reset_n  ,
  output [0:0]    ddr3_ck_p     ,
  output [0:0]    ddr3_ck_n     ,
  output [0:0]    ddr3_cke      ,
  output [0:0]    ddr3_cs_n     ,
  output [1:0]    ddr3_dm       ,
  output [0:0]    ddr3_odt      
);
//Resolution_1920x1080  @50HZʱΪ123.75MHz;@60HZʱΪ148.5MHz
parameter DISP_WIDTH  = 1920;
parameter DISP_HEIGHT = 1080;

//*********************************
//Internal connect
//*********************************
  //clock
  wire          pll_locked;
  wire          loc_clk50m;
  wire          loc_clk100m;
  wire          loc_clk24m;
  wire          loc_clk200m;
  wire          dvi_pll_locked;
  wire          pixelclk;
  wire          pixelclk5x;
  //reset
  wire          g_rst_p;
  //camera interface
  wire          camera_init_done;
  wire          pclk_bufg_o;
  wire [15:0]   image_data;
  wire          image_data_valid;
  wire          image_data_hs;
  wire          image_data_vs;
  //wr_fifo Interface
  wire          wrfifo_clr;
  wire          wrfifo_wren;
  wire [15:0]   wrfifo_din;
  //rd_fifo Interface
  wire          rdfifo_clr;
  wire          rdfifo_rden;
  wire [15 :0]  rdfifo_dout;
  //mig Interface 
  wire          ddr3_rst_n;
  wire          ddr3_init_done;
  //tft
  wire          frame_begin;

  wire [11:0]   disp_h_addr;
  wire [11:0]   disp_v_addr;
  wire          disp_data_req;
  wire [23:0]   disp_data;
  wire          disp_hs;
  wire          disp_vs;
  wire [7:0]    disp_red;
  wire [7:0]    disp_green;
  wire [7:0]    disp_blue;
  wire          disp_de;
  wire          disp_pclk;

  assign ddr3_rst_n = pll_locked;
  assign g_rst_p = (~ddr3_init_done)| (~dvi_pll_locked);

  assign led = {camera_init_done,ddr3_init_done,dvi_pll_locked,pll_locked};

  pll pll
  (
    // Clock out ports
    .clk_out1 (loc_clk50m   ), // output clk_out1
    .clk_out2 (loc_clk200m  ), // output clk_out2
    .clk_out3 (loc_clk100m  ), // output clk_out3
    .clk_out4 (loc_clk24m   ), // output clk_out3
    // Status and control signals
    .resetn   (reset_n      ), // input reset
    .locked   (pll_locked   ), // output locked
    // Clock in ports
    .clk_in1  (clk50m       )  // input clk_in1
  );

  dvi_pll dvi_pll
  (
    // Clock out ports
    .clk_out1(pixelclk       ),// output clk_out1
    .clk_out2(pixelclk5x     ),// output clk_out2
    // Status and control signals
    .resetn  (reset_n        ),// input reset
    .locked  (dvi_pll_locked ),// output locked
    // Clock in ports
    .clk_in1 (loc_clk100m    ) // input clk_in1
  );

  assign camera_xclk = loc_clk24m;

  camera_init
  #(
    .IMAGE_TYPE  ( 0            ),// 0: RGB; 1: JPEG
    .IMAGE_WIDTH ( DISP_WIDTH   ),// ͼƬ
    .IMAGE_HEIGHT( DISP_HEIGHT  ),// ͼƬ߶
    .IMAGE_FLIP  ( 0            ),// 0: ת1: ·ת
    .IMAGE_MIRROR( 0            ) // 0: 1: Ҿ
  )camera_init
  (
    .Clk         (loc_clk50m       ),
    .Rst_p       (g_rst_p          ),
    .Init_Done   (camera_init_done ),
    .camera_rst_n(camera_rst_n     ),
    .camera_pwdn (                 ),
    .i2c_sclk    (camera_sclk      ),
    .i2c_sdat    (camera_sdat      )
  );

  BUFG BUFG_inst (
    .O(pclk_bufg_o ), // 1-bit output: Clock output
    .I(camera_pclk )  // 1-bit input: Clock input
  );

  DVP_Capture DVP_Capture(
    .Rst_p      (g_rst_p          ),//input
    .PCLK       (pclk_bufg_o      ),//input
    .Vsync      (camera_vsync     ),//input
    .Href       (camera_href      ),//input
    .Data       (camera_data      ),//input     [7:0]

    .ImageState (                 ),//output reg
    .DataValid  (image_data_valid ),//output
    .DataPixel  (image_data       ),//output    [15:0]
    .DataHs     (image_data_hs    ),//output
    .DataVs     (image_data_vs    ),//output
    .Xaddr      (                 ),//output    [11:0]
    .Yaddr      (                 ) //output    [11:0]
  );

//---------------------------------------------
//ãʱsim_dat_genģ
//ʱȡsim_dat_genģ飬DVP_Captureģ
//---------------------------------------------
//  sim_dat_gen #(
//    .DISP_WIDTH  (DISP_WIDTH   ),
//    .DISP_HEIGHT (DISP_HEIGHT  ),
//    .DATA_WIDTH  (16           )
//  )
//  sim_dat_gen(
//    .clk          (pclk_bufg_o     ),
//    .reset        (g_rst_p         ),
//    .gen_en       (camera_init_done),
//    .sim_dat      (image_data      ),
//    .sim_dat_vaild(image_data_valid)
//  );
//-------------------------------------------

  reg frame_begin_dly1;

  always@(posedge pixelclk)
    frame_begin_dly1 <= frame_begin;

  assign wrfifo_wren = image_data_valid;
  assign wrfifo_din = image_data;
  assign wrfifo_clr = ~camera_init_done || g_rst_p;
  assign rdfifo_clr = frame_begin | frame_begin_dly1;

  assign disp_data = {rdfifo_dout[15:11],3'd0,rdfifo_dout[10:5],2'd0,rdfifo_dout[4:0],3'd0};
  assign rdfifo_rden = disp_data_req;

  disp_driver disp_driver(
    .ClkDisp     (pixelclk     ),
    .Rst_p       (g_rst_p      ),

    .Data        (disp_data    ),
    .DataReq     (disp_data_req),

    .H_Addr      (disp_h_addr  ),
    .V_Addr      (disp_v_addr  ),

    .Disp_HS     (disp_hs      ),
    .Disp_VS     (disp_vs      ),
    .Disp_Red    (disp_red     ),
    .Disp_Green  (disp_green   ),
    .Disp_Blue   (disp_blue    ),
    .Frame_Begin (frame_begin  ),
    .Disp_DE     (disp_de      ),
    .Disp_PCLK   (disp_pclk    )
  );
  //TFT
  reg [15:0]r_tft_rgb;
  reg       r_tft_hs;
  reg       r_tft_vs;
  reg       r_tft_de;
  //1
  always@(posedge disp_pclk)
  begin
    r_tft_rgb <= {disp_red[7:3],disp_green[7:2],disp_blue[7:3]};
    r_tft_hs  <= disp_hs;
    r_tft_vs  <= disp_vs;
    r_tft_de  <= disp_de;
  end

  assign TFT_clk = ~disp_pclk;
  assign TFT_rgb = r_tft_rgb;
  assign TFT_hs  = r_tft_hs;
  assign TFT_vs  = r_tft_vs;
  assign TFT_de  = r_tft_de;
  assign TFT_pwm = 1'b1;

  //HDMI1
  dvi_encoder dvi_encoder1(
    .pixelclk    (pixelclk    ),
    .pixelclk5x  (pixelclk5x  ),
    .rst_p       (g_rst_p     ),
    .blue_din    (disp_blue   ),
    .green_din   (disp_green  ),
    .red_din     (disp_red    ),
    .hsync       (disp_hs     ),
    .vsync       (disp_vs     ),
    .de          (disp_de     ),
    .tmds_clk_p  (hdmi1_clk_p ),
    .tmds_clk_n  (hdmi1_clk_n ),
    .tmds_data_p (hdmi1_dat_p ),
    .tmds_data_n (hdmi1_dat_n )
  );

  assign hdmi1_oe = 1'b1;
  //HDMI2
  dvi_encoder dvi_encoder2(
    .pixelclk    (pixelclk    ),
    .pixelclk5x  (pixelclk5x  ),
    .rst_p       (g_rst_p     ),
    .blue_din    (disp_blue   ),
    .green_din   (disp_green  ),
    .red_din     (disp_red    ),
    .hsync       (disp_hs     ),
    .vsync       (disp_vs     ),
    .de          (disp_de     ),
    .tmds_clk_p  (hdmi2_clk_p ),
    .tmds_clk_n  (hdmi2_clk_n ),
    .tmds_data_p (hdmi2_dat_p ),
    .tmds_data_n (hdmi2_dat_n )
  );

  assign hdmi2_oe = 1'b1;

  ddr3_ctrl_2port #(
    .BUF1_ADDR_BEGIN ( 0                           ),
    .BUF1_ADDR_END   ( DISP_WIDTH*DISP_HEIGHT*2    ),
    .BUF2_ADDR_BEGIN ( DISP_WIDTH*DISP_HEIGHT*2+256),
    .BUF2_ADDR_END   ( DISP_WIDTH*DISP_HEIGHT*4+256),
    .EN_DOUBLE_BUF   ( "YES"                       )
  )
  ddr3_ctrl_2port(
    //clock reset
    .ddr3_clk200m  (loc_clk200m   ),
    .ddr3_rst_n    (ddr3_rst_n    ),
    .ddr3_init_done(ddr3_init_done),
    //wr_fifo Interface
    .wrfifo_clr    (wrfifo_clr    ),
    .wrfifo_clk    (pclk_bufg_o   ),
    .wrfifo_wren   (wrfifo_wren   ),
    .wrfifo_din    (wrfifo_din    ),
    .wrfifo_full   (              ),
    .wrfifo_wr_cnt (              ),
    //rd_fifo Interface
    .rdfifo_clr    (rdfifo_clr    ),
    .rdfifo_clk    (pixelclk      ),
    .rdfifo_rden   (rdfifo_rden   ),
    .rdfifo_dout   (rdfifo_dout   ),
    .rdfifo_empty  (              ),
    .rdfifo_rd_cnt (              ),
    //DDR3 Interface
    // Inouts
    .ddr3_dq       (ddr3_dq       ),
    .ddr3_dqs_n    (ddr3_dqs_n    ),
    .ddr3_dqs_p    (ddr3_dqs_p    ),
    // Outputs      
    .ddr3_addr     (ddr3_addr     ),
    .ddr3_ba       (ddr3_ba       ),
    .ddr3_ras_n    (ddr3_ras_n    ),
    .ddr3_cas_n    (ddr3_cas_n    ),
    .ddr3_we_n     (ddr3_we_n     ),
    .ddr3_reset_n  (ddr3_reset_n  ),
    .ddr3_ck_p     (ddr3_ck_p     ),
    .ddr3_ck_n     (ddr3_ck_n     ),
    .ddr3_cke      (ddr3_cke      ),
    .ddr3_cs_n     (ddr3_cs_n     ),
    .ddr3_dm       (ddr3_dm       ),
    .ddr3_odt      (ddr3_odt      )
  );

endmodule